/*
 * 
 */
package swml.diagram.edit.policies;

import org.eclipse.emf.transaction.TransactionalEditingDomain;
import org.eclipse.gef.commands.Command;
import org.eclipse.gmf.runtime.diagram.ui.editparts.IGraphicalEditPart;
import org.eclipse.gmf.runtime.emf.commands.core.commands.DuplicateEObjectsCommand;
import org.eclipse.gmf.runtime.emf.type.core.requests.CreateElementRequest;
import org.eclipse.gmf.runtime.emf.type.core.requests.DuplicateElementsRequest;

import swml.diagram.edit.commands.ContentLayerCreateCommand;
import swml.diagram.edit.commands.HypertextLayerCreateCommand;
import swml.diagram.providers.SwmlElementTypes;

/**
 * @generated
 */
public class WebModelItemSemanticEditPolicy extends
		SwmlBaseItemSemanticEditPolicy {

	/**
	 * @generated
	 */
	public WebModelItemSemanticEditPolicy() {
		super(SwmlElementTypes.WebModel_1000);
	}

	/**
	 * @generated
	 */
	protected Command getCreateCommand(CreateElementRequest req) {
		if (SwmlElementTypes.HypertextLayer_2001 == req.getElementType()) {
			return getGEFWrapper(new HypertextLayerCreateCommand(req));
		}
		if (SwmlElementTypes.ContentLayer_2002 == req.getElementType()) {
			return getGEFWrapper(new ContentLayerCreateCommand(req));
		}
		return super.getCreateCommand(req);
	}

	/**
	 * @generated
	 */
	protected Command getDuplicateCommand(DuplicateElementsRequest req) {
		TransactionalEditingDomain editingDomain = ((IGraphicalEditPart) getHost())
				.getEditingDomain();
		return getGEFWrapper(new DuplicateAnythingCommand(editingDomain, req));
	}

	/**
	 * @generated
	 */
	private static class DuplicateAnythingCommand extends
			DuplicateEObjectsCommand {

		/**
		 * @generated
		 */
		public DuplicateAnythingCommand(
				TransactionalEditingDomain editingDomain,
				DuplicateElementsRequest req) {
			super(editingDomain, req.getLabel(), req
					.getElementsToBeDuplicated(), req
					.getAllDuplicatedElementsMap());
		}

	}

}
